/*****************************************************************************
    acl.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2003 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef ACL_H
#define ACL_H
/*
	ACL (Access List) structure definitions
*/ 
#include "types.h"

typedef struct acl_s {  int		perm;
			in_addr_t	addr;
			in_addr_t	mask; } acl_t;

#define PERM_NONE	0
#define	PERM_READ	1
#define	PERM_WRITE	2
#define	PERM_CREATE	4
#define PERM_APPEND	8
#define	PERM_DENY	0x10
#define PERM_DISCARD    0x20

#define PERM_MASK       0x0f
#define PERM_EMASK      0x3f

#define PERM_CLEAR      0x100
#define PERM_ALIAS      0x200
#define PERM_DONE       0x400

#define PERM_WRCRAP	(PERM_WRITE | PERM_CREATE | PERM_APPEND)


#define IPMASK_HOST	((in_addr_t)0xffffffff)
#define IPMASK_ANY	((in_addr_t)0)

#define C_IPMASK_HOST	"255.255.255.255"
#define C_IPMASK_ANY	"0.0.0.0"

typedef struct perm_s  { char *name;
                         int  mask; } perm_t;

#endif /* ACL_H */
